HDU:1503 Advanced Fruits(LCS+标记路径+输出)

40 篇文章 0 订阅
24 篇文章 0 订阅

Advanced Fruits

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 2995    Accepted Submission(s): 1531
Special Judge


Problem Description
The company "21st Century Fruits" has specialized in creating new sorts of fruits by transferring genes from one fruit into the genome of another one. Most times this method doesn't work, but sometimes, in very rare cases, a new fruit emerges that tastes like a mixture between both of them.  
A big topic of discussion inside the company is "How should the new creations be called?" A mixture between an apple and a pear could be called an apple-pear, of course, but this doesn't sound very interesting. The boss finally decides to use the shortest string that contains both names of the original fruits as sub-strings as the new name. For instance, "applear" contains "apple" and "pear" (APPLEar and apPlEAR), and there is no shorter string that has the same property.  

A combination of a cranberry and a boysenberry would therefore be called a "boysecranberry" or a "craboysenberry", for example.  

Your job is to write a program that computes such a shortest name for a combination of two given fruits. Your algorithm should be efficient, otherwise it is unlikely that it will execute in the alloted time for long fruit names.  
 

Input
Each line of the input contains two strings that represent the names of the fruits that should be combined. All names have a maximum length of 100 and only consist of alphabetic characters.

Input is terminated by end of file.  
 

Output
For each test case, output the shortest name of the resulting fruit on one line. If more than one shortest name is possible, any one is acceptable.
 

Sample Input
  
  
apple peach ananas banana pear peach
 

Sample Output
  
  
appleach bananas pearch
 

Source
 

Recommend
linle   |   We have carefully selected several similar problems for you:   1502  1501  1227  1080  1158 
 
题目大意:给你两个字符串,让你新构建一个字符串,使得新构建的字符串含有输入的两个字符串。
解题思路:第一步先把公共子序列求出来;
第二步标记最长公共子序列;
第三步输出,如果是最长子序列输出一次就可以了。
代码如下:
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
char a[110],b[110];
int dp[110][110];
int len1,len2;
void lcs()
{
	if(dp[len1][len2]==0)//没有公共子序列 
	{
		printf("%s%s\n",a,b);
	}
	else
	{
		int flag1[110];//标记字符串1中的最长公共子序列元素 
		int flag2[110];//标记字符串2中的最长公共子序列元素 
		memset(flag1,0,sizeof(flag1));
		memset(flag2,0,sizeof(flag2));
		int i=len1,j=len2;
		while(i!=0&&j!=0)//因为之前是正着找最长公共子序列的,所以这里标记最长公共子序列的时候应该倒着找 
		{
			if(a[i-1]==b[j-1]&&dp[i][j]==dp[i-1][j-1]+1)//看dp[i][j]是怎么来的 
			{
				flag1[i-1]=1;
				flag2[j-1]=1;
				i--;
				j--;
			}
			else
			{
					if(dp[i-1][j]>dp[i][j-1])//说明dp[i][j]是从第一串来的 
					{
						i--;
					}
					else//说明dp[i][j]是从第二串来的 
					{
						j--;
					}
			}
		}
		i=0,j=0;
		while(i<len1||j<len2)//这样保证全部能输出 
		{
			while(flag1[i]==0&&i<len1)//不是公共子序列那么就输出,知道到达公共子序列位置为止,记得限制i、j 
			{
				printf("%c",a[i]);
				i++;
			}
			while(flag2[j]==0&&j<len2)//不是公共子序列那么就输出,知道到达公共子序列位置为止,记得限制i、j 
			{
				printf("%c",b[j]);
				j++;
			}
			printf("%c",a[i]);//之前肯定都到达了公共子序列,那么随意输出其中一个序列的公共子序列即可,然后i++,j++,跳过当前输出的公共子序列 
			i++,j++;
		}
		printf("\n");
	}
}
int main()
{
	while(scanf("%s %s",a,b)!=EOF)
	{
		memset(dp,0,sizeof(dp));
		len1=strlen(a);
		len2=strlen(b);
		for(int i=1;i<=len1;i++)//找出最长公共子序列 
		{
			for(int j=1;j<=len2;j++)
			{
				if(a[i-1]==b[j-1])
				{
					dp[i][j]=dp[i-1][j-1]+1;
				}
				else
				{
					dp[i][j]=max(dp[i-1][j],dp[i][j-1]);
				}
			}
		}
		lcs();
	}
	return 0;
}

 
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值